; Alimentation variable  zro central pour pont tournant Jouef - Synoptique.txt  isis 7.8 sp2
;
; Alimentation pour moteur 12 volts par commande par potentiomtre  zro centrale.
; Potentiomtre, pour commander la vitesse de rotation,  point milieu, avec une zone centrale neutre ajustable par configuration.
;
; Mise  jour : 27 / 05 / 2018
; Version avec zone neutre centrale = 15 + commence  5 % de rapprot cyclique + courbe exponentielle du rapport % cyclique - % potentiomtre.
; La conversion angle du potentiomtre => Vitesse du moteur s'appuit sur une table de transfert. 
; 3 tableaux correspondant  3 courbes sont disponibles en fin de programme, il faut recopier celle souhaite dans le corps du prgramme.
;
;  Entre GP1 = Lecture potentiomtre vitesse (100 Kohms)
;  Sortie GP0 = 0 et GP5 = 1 = Rotation horaire (IN 1 L293D)
;  Sortie GP0 = 1 et GP5 = 0 = Rotation anti-horaire (IN 2 L293D)
;  Sortie GP4 = 0 = Moteur  l'arrt, 1 = Moteur en marche (Enable L293D)
;  Sortie GP2 = 0 = Moteur  l'arrt, clignotant = Si moteur en marche pour faire clignoter une led.
;  Entre GP3 = ? Pas utilise.
;----------------------------------------------------------------------------------------------------------------

	LIST      	p=PIC12F675     	; Dfinition du processeur
	#INCLUDE 	<p12F675.inc> 		; Dfinitions des constantes
	ERRORLEVEL 	-302
	__CONFIG  _CPD_OFF & _BODEN_OFF  & _CP_OFF & _WDT_OFF & _PWRTE_ON & _MCLRE_OFF & _INTRC_OSC_NOCLKOUT 
						; oscillateur interne 4 MHz

Zone_neutre	equ .15			; Zone centrale neutre du potentiomtre (.15 par dfaut, de .1  .50 )
					; Si l'on change cette valeur, il faut recalculer la courbe de transfert.
Frequence	equ .26			; Frquence de la sortie PWM (.26 par dfaut pour 100 Hz. de .1 a .55)
					;  .1  = 750 Hz (Pour Zone_neutre = 10)
					;  .3 =  500 Hz,  .4 =  420 Hz,  .5  = 350 Hz,  .11  = 200 Hz,  .26  = 100 Hz  .57  = 50 Hz
Type_de_courbe	equ .2			;  .1 => Table1 exponentielle,   
					;  .2 => Table2 linaire,
					;  .3 => Table3 exponentielle inverse.
;
BANK0	macro
	bcf	STATUS , RP0		; passer en banque0
	endm
BANK1	macro
	bsf	STATUS , RP0		; passer en banque1
	endm

	CBLOCK 0x020  			; Dbut de la zone des variables  
	Mesure				; Valeur mesure entre (entre 0 et 255) 
	Vitesse				; Vitesse
	Vitesse2			; Vitesse corrige par la courbe exponentielle
	Sens				; Sens positif/ngatif
	Cmpt1				; Compteur de boucle
	Cmpt2				; Compteur de boucle
	Cmpt3				; Compteur de clignotement
	ENDC				; Fin de la zone des variables    
;
; Dmarrage sur reset
;**********************************************************************
	org 	0x000 			; Adresse de dpart aprs reset
  	goto    init			; Adresse 0: initialiser
	org 	0x004			; adresse d'interruption
	retfie  			; return from interrupt
;
; Initialisation gnrale
;*********************************************************************
init
	BANK1		        	; set file register bank to 1 
	call    3FFh           		; retrieve factory calibration value
	movwf   OSCCAL          	; update register with factory cal value 
	clrf	INTCON			; Pas d'interruption.
	movlw	B'10010010'		; bit 7 GPPU:GPIO Pull-up Enable bit       1 = GPIO pull-ups are disabled
					; bit 6 INTEDG:Interrupt Edge Select bit   0 = Interrupt on falling edge of GP2/INT pin
					; bit 5 T0CS:TMR0 Clock Source Select bit  0 = Internal instruction cycle clock (CLKOUT)
					; bit 4 T0SE:TMR0 Source Edge Select bit   0 = Increment on low-to-high transition on GP2/T0CKI pin
					; bit 3 PSA:Prescaler Assignment bit       0 = Prescaler is assigned to the TIMER0 module
	movwf	OPTION_REG		; bit 2-0 PS2:PS0:Prescaler Rate Select bits 000 = 1/2
	clrf	IOC			; IOC: INTERRUPT-ON-CHANGE GPIO REGISTER
	clrf	PIE1			; PIE1: PERIPHERAL INTERRUPT ENABLE REGISTER 1
	clrf	VRCON			; VRCON: VOLTAGE REFERENCE CONTROL REGISTER
	movlw	B'01100010'		; Entres analogiques	
	movwf	ANSEL			; x110 = fosc/64 et ANSx=0010 -> AN1 en mode analogique, 0,2,3 en mode numrique
	BANK0
	clrf	T1CON			; T1CON: TIMER1 CONTROL REGISTER
	movlw	b'00000111'		; Comparateurs  l'arrt
	movwf	CMCON			; CMCON: COMPARATOR CONTROL REGISTER
	movlw	b'00000101'		; Entres analogiques	
					; b7  0 : Rsultat cal  gauche (8 bits forts, octet bas nglig)
					; b6  0 : Rfrence interne = Vcc
					; b5-b4  00 : Non Utilis
					; b3-b2  01 : Choix entre AN1 (= GP1 = patte n 6)
					; b1  0 : Pas de demande de conversion
					; b0  1 : Convertisseur analogique en marche
	movwf	ADCON0			; AN1 selectionn en attente d'une conversion

; Boucle principale
;**********************************************************************
	clrf	Vitesse			; Vitesse = 0
	clrf	Vitesse2		; Vitesse2 = 0
	bcf  	GPIO,0			; Raz sortie patte n 7 - (IN 1 L293D)
	bcf  	GPIO,5			; Raz sortie patte n 2 - (IN 2 L293D)
	bcf  	GPIO,4			; Raz sortie patte n 3 - (ENABLE L293D)
	bcf  	GPIO,2			; Eteint la led clignotante
	BANK1
	movlw	B'00001010'		; 0 = Sorties valides	
	movwf	TRISIO			; Sorties = GP0, GP2, GP4 et GP5 + Entre = GP1 => 000010
	BANK0
	bcf	PIR1,ADIF
	bsf 	ADCON0,1		; Lance la mesure sur l'entre analogique AN1
;
Boucle	btfss	PIR1,ADIF		; Teste si la mesure analogique est finie
	goto	Suite2			; Si c'est pas fini, on continu  sortir le signal  la mme vitesse.
; 
; Mesure  faire = > On change la valeur de la vitesse.
;
	movf	ADRESH, W		; Transfre le rsultat dans W
	movwf	Mesure			; Transfre W dans la variable "Mesure"
	bcf	PIR1,ADIF
	movlw	.127+Zone_neutre+1
	subwf	Mesure, W
	btfss   STATUS,C
	goto	Bcl_2
;					; Si Mesure > 127 + Zone_neutre + 1
	movwf	Vitesse			; Vitesse = Mesure -127 -Zone_neutre + 1
	movlw	1
	movwf	Sens		
	bsf  	GPIO,4			; Pour ensuite GP0 = 1 et GP5 = 0 (Rotation horaire) 
	goto	Suite1
Bcl_2	movfw	Mesure		
	sublw	.127-Zone_neutre
	btfss   STATUS,C
	goto	Bcl_3
;					; Si Mesure < 127 - Zone_neutre
	movwf	Vitesse			; Vitesse = 127 - Mesure - Zone_neutre
	movlw	2
	movwf	Sens		
	bsf  	GPIO,4			;  Pour ensuite GP0 = 0 et GP5 = 1 (Rotation anti-horaire) 
	goto	Suite1
;					; Si 127 - Zone_neutre > Mesure > 127 + Zone_neutre +1
Bcl_3	clrf	Vitesse			; Vitesse = 0
	movlw	0
	movwf	Sens		
	bcf  	GPIO,4			; GP4 = 0 (ENABLE L293D)=0
	bcf  	GPIO,0			; GP0 = 0 et GP5 = 1 (IN 1 L293D)=0 et (IN 2 L293D)=0
	bcf  	GPIO,5
	bcf  	GPIO,2			; Eteint la led clignotante
Suite1	movlw	.10
	movwf	Cmpt2			; Attendre avant de relancer une conversion CAN
Tempo_1	decfsz	Cmpt2,f			; dcrmenter compteur2
	goto	Tempo_1			; si pas 0, boucler
	bsf 	ADCON0,1		; Lance la conversion sur l'entre analogique n 1
;
; Si pas de mesure = > On n'a pas chang la valeur de la vitesse.
;
Suite2	movlw	Type_de_courbe
	sublw	.1
	btfss   STATUS,Z
	goto	Suite3	
	movlw	0x01			; Conversion : vitesse lue => vitesse calcule par courbe de transfert
	movwf	PCLATH
	movfw	Vitesse	
	call	Vitesse_table1		; COURBE 1
	movwf	Vitesse2		; Vitesse = > Vitesse2
	goto	Suite5	

Suite3	movlw	Type_de_courbe
	sublw	.2
	btfss   STATUS,Z
	goto	Suite4	
	movlw	0x02			; Conversion : vitesse lue => vitesse calcule par courbe de transfert
	movwf	PCLATH
	movfw	Vitesse	
	call	Vitesse_table2		; COURBE 2
	movwf	Vitesse2		; Vitesse = > Vitesse2
	goto	Suite5	

Suite4	movlw	0x03			; Conversion : vitesse lue => vitesse calcule par courbe de transfert
	movwf	PCLATH
	movfw	Vitesse	
	call	Vitesse_table3		; COURBE 3
	movwf	Vitesse2		; Vitesse = > Vitesse2
	
Suite5	incf	Cmpt3
	movfw	Vitesse2
	btfsc   STATUS,Z
	goto	Boucle			; Vitesse nulle -> On boucle
;
	btfsc	Sens,0
	bsf  	GPIO,5			; GP0 = 0 et GP5 = 1 (Rotation anti-horaire) 

	btfsc	Sens,1
	bsf  	GPIO,0			; GP0 = 1 et GP0 = 0 (Rotation horaire) 

	btfsc	Cmpt3,5
	bsf  	GPIO,2			; Allume la led clignotante
	btfss	Cmpt3,5
	bcf  	GPIO,2			; Eteint led clignotante

	movfw	Vitesse2
	movwf	Cmpt1			; Compteur1 = Vitesse (temps aliment de 1  Vitesse  = Nombre de boucle  faire moteur allum)
;
Bcl_10	call	Tempo_2
	decfsz	Cmpt1,f			; Dcrmenter compteur1
	goto	Bcl_10			; si pas 0, boucler

	movfw	Vitesse2
	sublw	.127-Zone_neutre+1
	movwf	Cmpt1			; Compteur1 = 127 - Zone_neutre - 1 - Vitesse (temps aliment de Vitesse-1  0 = Nombre de boucle  faire moteur tient
	sublw	1	
	btfsc   STATUS,Z
	goto	Boucle			; Si vitesse = maximum, pour avoir 100% potentiomtre  fond on ne passe pas en pause.

	btfsc	Sens,0
	bcf  	GPIO,5			; GP0 = 0 et GP5 = 0 (Arret Rotation anti-horaire) 

	btfsc	Sens,1
	bcf  	GPIO,0			; GP0 = 0 et GP0 = 0 (Arret Rotation horaire) 
;
Bcl_11	call	Tempo_2
	decfsz	Cmpt1,f			; dcrmenter compteur1
	goto	Bcl_11			; si pas 0, boucler
	goto	Boucle			; Vitesse nulle -> On boucle
;
Tempo_2	movlw	Frequence
	movwf	Cmpt2			; Initialiser le compteur2
Tempo_3	decfsz	Cmpt2,f			; dcrmenter compteur2
	goto	Tempo_3			; si pas 0, boucler
	return

; Utilisation de la table de vitesse, pour avoir une vitesse de rotation proportionelle au potentiomtre.
; et une vitesse de minimum de 5.
; 	movlw	0x01  ou  0x02  ou  0x03 (suivant la table)
;	movwf	PCLATH
;	movfw	Vitesse
;	call	Vitesse_table
; Valeur maxi en sortie  = 112 si la zone morte = 15. Sinon ajuster ce tableau.

; COURBE EXPONENTIELLE (TABLE 1)
	ORG 0x100		; Adresse des tableaux en fin de mmoire (moins de 256 octets)
Vitesse_table1: 
	addwf	PCL,f		; Ajouter w  PCL
	retlw	.0	;   0   ; Courbe = 5 + 0,1*X + 0,0078*X
	retlw	.5	;   1
	retlw	.5	;   2
	retlw	.5	;   3
	retlw	.6	;   4
	retlw	.6	;   5
	retlw	.6	;   6
	retlw	.6	;   7
	retlw	.6	;   8
	retlw	.7	;   9
	retlw	.7	;   10
	retlw	.7	;   11
	retlw	.7	;   12
	retlw	.8	;   13
	retlw	.8	;   14
	retlw	.8	;   15
	retlw	.9	;   16
	retlw	.9	;   17
	retlw	.9	;   18
	retlw	.10	;   19
	retlw	.10	;   20
	retlw	.11	;   21
	retlw	.11	;   22
	retlw	.11	;   23
	retlw	.12	;   24
	retlw	.12	;   25
	retlw	.13	;   26
	retlw	.13	;   27
	retlw	.14	;   28
	retlw	.14	;   29
	retlw	.15	;   30
	retlw	.16	;   31
	retlw	.16	;   32
	retlw	.17	;   33
	retlw	.17	;   34
	retlw	.18	;   35
	retlw	.19	;   36
	retlw	.19	;   37
	retlw	.20	;   38
	retlw	.21	;   39
	retlw	.21	;   40
	retlw	.22	;   41
	retlw	.23	;   42
	retlw	.24	;   43
	retlw	.25	;   44
	retlw	.25	;   45
	retlw	.26	;   46
	retlw	.27	;   47
	retlw	.28	;   48
	retlw	.29	;   49
	retlw	.30	;   50
	retlw	.30	;   51
	retlw	.31	;   52
	retlw	.32	;   53
	retlw	.33	;   54
	retlw	.34	;   55
	retlw	.35	;   56
	retlw	.36	;   57
	retlw	.37	;   58
	retlw	.38	;   59
	retlw	.39	;   60
	retlw	.40	;   61
	retlw	.41	;   62
	retlw	.42	;   63
	retlw	.43	;   64
	retlw	.44	;   65
	retlw	.46	;   66
	retlw	.47	;   67
	retlw	.48	;   68
	retlw	.49	;   69
	retlw	.50	;   70
	retlw	.51	;   71
	retlw	.53	;   72
	retlw	.54	;   73
	retlw	.55	;   74
	retlw	.56	;   75
	retlw	.58	;   76
	retlw	.59	;   77
	retlw	.60	;   78
	retlw	.62	;   79
	retlw	.63	;   80
	retlw	.64	;   81
	retlw	.66	;   82
	retlw	.67	;   83
	retlw	.68	;   84
	retlw	.70	;   85
	retlw	.71	;   86
	retlw	.73	;   87
	retlw	.74	;   88
	retlw	.76	;   89
	retlw	.77	;   90
	retlw	.79	;   91
	retlw	.80	;   92
	retlw	.82	;   93
	retlw	.83	;   94
	retlw	.85	;   95
	retlw	.86	;   96
	retlw	.88	;   97
	retlw	.90	;   98
	retlw	.91	;   99
	retlw	.93	;   100
	retlw	.95	;   101
	retlw	.96	;   102
	retlw	.98	;   103
	retlw	.100	;   104
	retlw	.101	;   105
	retlw	.103	;   106
	retlw	.105	;   107
	retlw	.107	;   108
	retlw	.109	;   109
	retlw	.112	;   110
	retlw	.112	;   111
	retlw	.112	;   112
	retlw	.112	;   113
	retlw	.112	;   114
	retlw	.112	;   115
	retlw	.112	;   116
	retlw	.112	;   117


; COURBE LINEAIRE (TABLE 2)
; La vitesse du moteur est proportionnel  l'angle du potentiomtre.
	ORG 0x200		; Adresse des tableaux en fin de mmoire (moins de 256 octets)
Vitesse_table2: 
	addwf	PCL,f		; Ajouter w  PCL
	retlw	.0	;  0    ; Courbe = 5 + 0,96*X
	retlw	.5	;  1
	retlw	.6	;  2
	retlw	.8	;  3
	retlw	.9	;  4
	retlw	.10	;  5
	retlw	.11	;  6
	retlw	.12	;  7
	retlw	.13	;  8
	retlw	.14	;  9
	retlw	.15	;  10
	retlw	.16	;  11
	retlw	.17	;  12
	retlw	.17	;  13
	retlw	.18	;  14
	retlw	.19	;  15
	retlw	.20	;  16
	retlw	.21	;  17
	retlw	.22	;  18
	retlw	.23	;  19
	retlw	.24	;  20
	retlw	.25	;  21
	retlw	.26	;  22
	retlw	.27	;  23
	retlw	.28	;  24
	retlw	.29	;  25
	retlw	.30	;  26
	retlw	.31	;  27
	retlw	.32	;  28
	retlw	.33	;  29
	retlw	.34	;  30
	retlw	.35	;  31
	retlw	.36	;  32
	retlw	.37	;  33
	retlw	.38	;  34
	retlw	.39	;  35
	retlw	.40	;  36
	retlw	.41	;  37
	retlw	.41	;  38
	retlw	.42	;  39
	retlw	.43	;  40
	retlw	.44	;  41
	retlw	.45	;  42
	retlw	.46	;  43
	retlw	.47	;  44
	retlw	.48	;  45
	retlw	.49	;  46
	retlw	.50	;  47
	retlw	.51	;  48
	retlw	.52	;  49
	retlw	.53	;  50
	retlw	.54	;  51
	retlw	.55	;  52
	retlw	.56	;  53
	retlw	.57	;  54
	retlw	.58	;  55
	retlw	.59	;  56
	retlw	.60	;  57
	retlw	.61	;  58
	retlw	.62	;  59
	retlw	.63	;  60
	retlw	.64	;  61
	retlw	.65	;  62
	retlw	.65	;  63
	retlw	.66	;  64
	retlw	.67	;  65
	retlw	.68	;  66
	retlw	.69	;  67
	retlw	.70	;  68
	retlw	.71	;  69
	retlw	.72	;  70
	retlw	.73	;  71
	retlw	.74	;  72
	retlw	.75	;  73
	retlw	.76	;  74
	retlw	.77	;  75
	retlw	.78	;  76
	retlw	.79	;  77
	retlw	.80	;  78
	retlw	.81	;  79
	retlw	.82	;  80
	retlw	.83	;  81
	retlw	.84	;  82
	retlw	.85	;  83
	retlw	.86	;  84
	retlw	.87	;  85
	retlw	.88	;  86
	retlw	.89	;  87
	retlw	.89	;  88
	retlw	.90	;  89
	retlw	.91	;  90
	retlw	.92	;  91
	retlw	.93	;  92
	retlw	.94	;  93
	retlw	.95	;  94
	retlw	.96	;  95
	retlw	.97	;  96
	retlw	.98	;  97
	retlw	.99	;  98
	retlw	.100	;  99
	retlw	.101	;  100
	retlw	.102	;  101
	retlw	.103	;  102
	retlw	.104	;  103
	retlw	.105	;  104
	retlw	.106	;  105
	retlw	.107	;  106
	retlw	.108	;  107
	retlw	.109	;  108
	retlw	.110	;  109
	retlw	.111	;  110
	retlw	.112	;  111
	retlw	.112	;  112
	retlw	.112	;  113
	retlw	.112	;  114
	retlw	.112	;  115
	retlw	.112	;  116
	retlw	.112	;  117
	
	
; COURBE EXPOTENTIELLE INVERSEE (TABLE 3)
; Dmarre rapidement puis plafonne en atteignant la vitesse maxi.
	ORG 0x300		; Adresse des tableaux en fin de mmoire (moins de 256 octets)
Vitesse_table3: 
	addwf	PCL,f		; Ajouter w  PCL
	retlw	.0	;  0    ; Courbe = 5 + 0,95X + 0,008*(X-112)*X
	retlw	.5	;  1
	retlw	.8	;  2
	retlw	.10	;  3
	retlw	.12	;  4
	retlw	.14	;  5
	retlw	.16	;  6
	retlw	.18	;  7
	retlw	.19	;  8
	retlw	.21	;  9
	retlw	.23	;  10
	retlw	.24	;  11
	retlw	.26	;  12
	retlw	.28	;  13
	retlw	.29	;  14
	retlw	.31	;  15
	retlw	.32	;  16
	retlw	.34	;  17
	retlw	.36	;  18
	retlw	.37	;  19
	retlw	.39	;  20
	retlw	.40	;  21
	retlw	.42	;  22
	retlw	.43	;  23
	retlw	.45	;  24
	retlw	.46	;  25
	retlw	.48	;  26
	retlw	.49	;  27
	retlw	.50	;  28
	retlw	.52	;  29
	retlw	.53	;  30
	retlw	.55	;  31
	retlw	.56	;  32
	retlw	.57	;  33
	retlw	.59	;  34
	retlw	.60	;  35
	retlw	.61	;  36
	retlw	.62	;  37
	retlw	.64	;  38
	retlw	.65	;  39
	retlw	.66	;  40
	retlw	.67	;  41
	retlw	.68	;  42
	retlw	.70	;  43
	retlw	.71	;  44
	retlw	.72	;  45
	retlw	.73	;  46
	retlw	.74	;  47
	retlw	.75	;  48
	retlw	.76	;  49
	retlw	.77	;  50
	retlw	.78	;  51
	retlw	.79	;  52
	retlw	.80	;  53
	retlw	.81	;  54
	retlw	.82	;  55
	retlw	.83	;  56
	retlw	.84	;  57
	retlw	.85	;  58
	retlw	.86	;  59
	retlw	.87	;  60
	retlw	.88	;  61
	retlw	.89	;  62
	retlw	.90	;  63
	retlw	.90	;  64
	retlw	.91	;  65
	retlw	.92	;  66
	retlw	.93	;  67
	retlw	.94	;  68
	retlw	.94	;  69
	retlw	.95	;  70
	retlw	.96	;  71
	retlw	.96	;  72
	retlw	.97	;  73
	retlw	.98	;  74
	retlw	.98	;  75
	retlw	.99	;  76
	retlw	.100	;  77
	retlw	.100	;  78
	retlw	.101	;  79
	retlw	.101	;  80
	retlw	.102	;  81
	retlw	.103	;  82
	retlw	.103	;  83
	retlw	.104	;  84
	retlw	.104	;  85
	retlw	.105	;  86
	retlw	.105	;  87
	retlw	.105	;  88
	retlw	.106	;  89
	retlw	.106	;  90
	retlw	.107	;  91
	retlw	.107	;  92
	retlw	.107	;  93
	retlw	.108	;  94
	retlw	.108	;  95
	retlw	.108	;  96
	retlw	.109	;  97
	retlw	.109	;  98
	retlw	.109	;  99
	retlw	.110	;  100
	retlw	.110	;  101
	retlw	.110	;  102
	retlw	.110	;  103
	retlw	.110	;  104
	retlw	.111	;  105
	retlw	.111	;  106
	retlw	.111	;  107
	retlw	.111	;  108
	retlw	.112	;  109
	retlw	.112	;  110
	retlw	.112	;  111
	retlw	.112	;  112
	retlw	.112	;  113
	retlw	.112	;  114
	retlw	.112	;  115
	retlw	.112	;  116
	retlw	.112	;  117

END
